<?php

function getFinHTML(): string {
    return "<!-- contenu -->
</body>
</html>
";
}

    // initialisation de la connexion via l'instance de MyPDO
$myPDOOenologue = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'oenologue');

    // initialisation du générateur de vues HTML
$vue = new VueOenologue();

    // initialisation des chaînes à afficher
$contenu = "";
$message = "";

    // traitement des différentes actions possibles

if (isset($_GET['action']))
    switch ($_GET['action']) {
        case 'read':
            $oenologue = $myPDOOenologue->get('id_oenologue', $_GET['id_oenologue']);
            $contenu .= $vue->getHTML4Oeonologue($oenologue);
            $_SESSION['etat'] = 'lecture';
            break;
        case 'create':
            $nbOenologue = $myPDOOenologue->count();
            $contenu .= $vue->getFormulaire4Oeonologue(array('id_oenologue' => array ('type'=>'number', 'default'=> $myPDOOenologue->getMax("id_oenologue")+1), 'nom_oenologue' => 'text'));
            $_SESSION['etat'] = 'création';
            break;
        case 'update':
            $oenologue = $myPDOOenologue->get('id_oenologue',$_GET['id_oenologue']);
            $contenu .= $vue->getFormulaire4Oeonologue(array('id_oenologue'=>array('type'=>'number','default'=>$oenologue->getIdOenologue()),
                'nom_oenologue'=>array('type'=>'text','default'=>$oenologue->getNomOenologue())));
            $_SESSION['etat'] = 'modification';
            break;
        case 'delete':
            $myPDOOenologue->delete(array('id_oenologue'=>$_GET['id_oenologue']));
            $_SESSION['etat'] = 'suppression';
            break;
        default:
            $message .= "<p>Action ".$_GET['action']." non implémentée.</p>\n";
    }

else
    if (isset($_SESSION['etat']))
        switch($_SESSION['etat']) {
            case 'création':
                $myPDOOenologue->insert(array('id_oenologue'=>$_GET['id_oenologue'], 'nom_oenologue'=>$_GET['nom_oenologue']));
                $_SESSION['etat'] = 'créé';
                break;
            case 'modification':
                $myPDOOenologue->update('id_oenologue', array('id_oenologue'=>$_GET['id_oenologue'], 'nom_oenologue'=>$_GET['nom_oenologue']));
                $_SESSION['etat'] = 'modifié';
                break;
            case 'suppression':
                $_SESSION['etat']= 'supprimé';
                break;
            case 'créé':
            case 'modifié':
            case 'supprimé':
            default:
                $_SESSION['etat'] = 'neutre';
        }


    // affichage du nombre total d'oenologues :
$nbOenologue = $myPDOOenologue->count();
$message .= "<p>La table oenologue contient ".$nbOenologue." enregistrements.</p>\n";

    // sélection/modification/suppression/ d'un oenologue

$contenu .=
        "<form action='?' method='GET'>
            <select name='action'>
            <option value='read'>Visualiser un oenologue</option>
            <option value='update'>Modifier</option>
            <option value='delete'>Supprimer</option>
            </select>
            <select name='id_oenologue'>";

$lesOenologues = array();

$iterateur = new OenologueIterator();
foreach ($iterateur as $oenologue)
{
    array_push($lesOenologues, $oenologue);
    $contenu .= "<option>".$iterateur->key()."</option>";
}

$contenu .= "</select>
    <input type='submit' name='envoi' value='Go' />
    </form>\n";

    // création d'un nouveau oenologue
    // Attention suppose que le nombre d'oenologues présents correspond au dernier identifiant attribué...
$contenu .="<p><a href='?action=create'>Créer oenologue ";
$contenu .= $myPDOOenologue->getMax("id_oenologue");
$contenu .= "</a> </p>";

    // récupération et affichage de la liste des oenologues avec liens vers édition/suppresion

$contenu .= $vue->getAllOeonologue($lesOenologues);

    // Production de la page HTML
echo $message;
echo $contenu;
echo getFinHTML();
